/* ZADATAK 2.
 * Redni broj trenutnog igraca proslijediti kao parametar programu (1, 2, 3, 4).
 * Igraca broj 4 prijaviti posljednjeg.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <time.h>

enum karta {
	HERC = 0,
	KARO = 1,
	PIK = 2,
	TREF = 3
};

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

char *get_karta(enum karta k);
 
int main(int argc, char **argv)
{	/* Deklaracija potrebnih promjenljivih. */
	union semun arg;
	key_t kljuc;
	int i, t, semid, shmid, sljedeci, *pod, br_igraca;
	
	/* Redni broj prijavljenog igraca, inicijalizacija srand()-a. */
	br_igraca = argv[1][0] - '0' - 1;
	srand(time(NULL));
	
	/* Dijeljena memorija (pod):
	 * 	1) pod[0] - indikator kretanja, tj: 1, 2, 3, ... za = 0 ili 2, 1, 4, ... za = 1.
	 * 	2) pod[1] - talon.
	 */
	kljuc = ftok("igrac.c", 10);
	semid = semget(kljuc, 4, 0644 | IPC_CREAT);
	kljuc = ftok("igrac.c", 20);
	shmid = shmget(kljuc, 2*sizeof(int), 0644 | IPC_CREAT);
	pod = shmat(shmid, NULL, 0);
	
	arg.val = 1;
	semctl(semid, br_igraca, SETVAL, arg);
	pod[0] = 0; /* Redosljed: 1, 2, ... */
	
	if(br_igraca == 3) {
		/* Cetvrti igrac prijavljen, neka igra krene, i to od prvog igraca. */
		arg.val = 0;
		semctl(semid, 0, SETVAL, arg);
	} else {
		/* U suprotnom, sacekaj dozvolu. */
		for(;;) {
			t = semctl(semid, br_igraca, GETVAL, arg);
			if(t == 0)
				goto begin;
		}
	}
	begin: for(;;) {
		for(; (t = semctl(semid, br_igraca, GETVAL, arg) != 0););
		/* Stampamo i pamtimo broj na karti. */
		printf("%2d %s\n", pod[1] = rand()%14+1, get_karta(rand()%4));
		sleep(1);
		
		/* Ako je karta = 8, okreni redosljed. */
		if(pod[1] == 8) {
			if(pod[0] == 1) pod[0]=0;
			else pod[0] = 1;
		}
		
		/* Sebi zabrani igru, sacekaj sljedeci krug. */
		arg.val=1;
		semctl(semid, br_igraca, SETVAL, arg);
		
		/* Proslijedi dozvolu iducem igracu, u zavisnosti od smjera kretanja. */
		arg.val=0;
		if(pod[0] == 0) {
			sljedeci = (br_igraca + 1) % 4;
		} else {
			if(br_igraca == 0) sljedeci = 3;
			else sljedeci = br_igraca -1;
		}
		semctl(semid, sljedeci, SETVAL, arg);
	}
	return 0;
}

char *get_karta(enum karta k)
{
	switch(k) {
		case HERC:
			return "HERC";
		case KARO:
			return "KARO";
		case PIK:
			return "PIK";
		case TREF:
			return "TREF";
	}
}
