#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf; 
	ushort *array;
};

int main(int argc ,char *argv[])
{
	
	key_t key;
	int semid,shmidk,shmidz,shmids;
	//shmidk za koriscenje id-ja za broj karte
	//shmidz za koriscenje id-ja za znak karte
	//shmids za koriscenje id-ja za smera igre
	int *dk,*dz,*ds;
	// dk za deljenu memoriju za broj karte
	// dz za deljenu memoriju za znak karte
	// ds za deljenu memoriju za smer igre
	
	union semun arg;
	
	//kreiranje semafora 
	key=ftok("./init.c",'A');
	printf("Kljuc za semafore je %d\n",key);
	semid=semget(key,4,IPC_CREAT | 0644);
	printf("Id za semafore je %d\n",semid);
	
	//pravimo 4 semafora jer imamo 4 igraca
	//igrac 1 samo on na pocetku mlze da igra ostali se blokiraju
	arg.val=1;
	semctl(semid,0,SETVAL,arg);
	//igrac 2
	arg.val=0;
	semctl(semid,1,SETVAL,arg);
	//igrac 3
	arg.val=0;
	semctl(semid,2,SETVAL,arg);
	//igrac 4
	arg.val=0;
	semctl(semid,3,SETVAL,arg);
	
	//kreiranje deljene memorije
	//Za broj karte
	key=ftok("./init.c",'K');
	printf("Kljuc za memoriju za broj karte %d\n",key);
	shmidk=shmget(key,1*sizeof(int),IPC_CREAT | 0644);
	printf("Id za broj karte %d\n",shmidk);
	
	//Za znak karte
	key=ftok("./init.c",'Z');
	printf("Kljuc za memoriju za znak karte %d\n",key);
	shmidz=shmget(key,1*sizeof(int),IPC_CREAT | 0644);
	printf("Id za znak karte %d\n",shmidz);
	
	//Za smer kretanja igre
	key=ftok("./init.c",'S');
	printf("Kljuc za memoriju za smer igre %d\n",key);
	shmids=shmget(key,1*sizeof(int),IPC_CREAT | 0644);
	printf("Id za smer igre %d\n",shmids);
	
	//kacimo se na memoriju
	
	dk=shmat(shmidk,NULL,0); // za broj
	dz=shmat(shmidz,NULL,0); // za znak	
	ds=shmat(shmids,NULL,0); // za smer
	
	//normalna smer 1-2-3-4-1... oznacavamo sa 0
	//suprotan smer 1-4-3-2-1... oznacavamo sa 1
	int p;
	srand(time(NULL));
	//postavljamo smer igre na pocetku je normalan
	*ds=0;
	
	//postavljamo pocetnu kartu
	p=rand()%14;
	p=p+1; // da nebismo imali nul vec brojeve od 1 do 14
	*dk=p; // pocetna kara
	if(p == 8)
		*ds=1;
	//postavljamo znak karte
	
	// 0 je herc
	// 1 je tref
	// 2 je karo
	// 3 je pik
	
	p=rand()%4;	
	*dz=p;
	printf("Prva karta na talonu je:\n");
	printf("Broj karte - %d\tZnak karte - %d\tSmer kretanja je - %d\n",*dk,*dz,*ds);	
		
	shmdt(dk);
	shmdt(ds);
	shmdt(dz);

}
