#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>
#include <time.h>

union semun
{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

struct talon
{
	long tip;
	int talon_broj;
	int talon_znak;
};

int semid;

void signal_handler(int sig)
{
	printf("Prekinut sam sa SISGINT,brisem semafor...\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
	exit(0);
}

int main()
{
	key_t kljuc;
	int karta_broj,karta_znak;
	union semun arg;
	struct sembuf opr_p,opr_v;
	int msgid;
	struct talon tabla;
	
	srand(time(NULL));
	kljuc = ftok("zadatak1.c",100);
	printf("Kljuc je %d\n",kljuc);
	
	signal(SIGINT,signal_handler);
	
	semid = semget(kljuc,4,0666|IPC_CREAT|IPC_EXCL);
	printf("ID semafora je %d\n",semid);
	
	if (semid != -1)
	{
		printf("Semafor nije postojao ja sam ga napravio\n");
		arg.val = 4;
		semctl(semid,0,SETVAL,arg);
		arg.val = 0;
		semctl(semid,1,SETVAL,arg);
		semctl(semid,2,SETVAL,arg);
		semctl(semid,3,SETVAL,arg);
	}
	else if (errno == EEXIST)
	{
		printf("Semafor je postojao,samo se povezujem\n");
		semid = semget(kljuc,1,0);
	}
	else
	{
		printf("Greska!\n");
		exit(0);
	}
	
	printf("Pravim red za poruke...\n");
	msgid = msgget(kljuc,IPC_CREAT);
	
	opr_p.sem_num = 3;
	opr_p.sem_op = -4;
	opr_p.sem_flg = 0;
	
	opr_v.sem_num = 0;
	opr_v.sem_op = 4;
	opr_v.sem_flg = 0;
	
	while(1)
	{
		semop(semid,&opr_p,1);
		sleep(5);
		msgrcv(msgid,&tabla,sizeof(tabla),3,0);
		karta_broj = (rand()%14) + 1;
		karta_znak = (rand()%4) + 1;
		printf("Izvukao sam kartu %d znak %d\n",karta_broj,karta_znak);
		if (tabla.talon_broj == karta_broj || tabla.talon_znak == karta_znak)
		{
			tabla.talon_broj = karta_broj;
			tabla.talon_znak = karta_znak;
			tabla.tip = 4;
			msgsnd(msgid,&tabla,sizeof(tabla),0);
		}
		else
		{
			tabla.tip = 4;
			msgsnd(msgid,&tabla,sizeof(tabla),0);
			printf("Nisam imao adekvatnu kartu!\n");
		}
		semop(semid,&opr_v,1);
		sleep(10);
		
	}	
}
