//MARKO JOVANOVIC 72 2018

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

int semid;
int shmid1, shmid2;
int idreda1, idreda2;

int *tk; //TALON KARTA
int *tz;  //TALON ZNAK

struct prijavaa
{
long tip; // tip poruke
int prijava; // tekst poruke
};

 struct igra
{
long tip; // tip poruke
int id; // tekst poruke
};

union semun {
int val;
/*used for SETVAL only */

struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */

ushort *array;
/* used for GETALL and SETALL */
 };

void izbrisiSemafore(int sig)
{
	printf("\nKRAJ\n");
	semctl(semid, 0, IPC_RMID); //brisanje sem
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	
	shmdt(tk); 				//brisanje mem
	shmdt(tz);
	shmctl(shmid1, IPC_RMID, NULL);
	shmctl(shmid2, IPC_RMID, NULL);
	
	exit(0);
}

int main()
{
	
	srand(time(NULL));
	signal(SIGINT, izbrisiSemafore);
	key_t kljuc;
	union semun opNadSemaforom;
	struct sembuf a1,a2,a3,a4; 
	
	struct prijavaa p;
	struct igra i;
	
	//kreiranje reda za poruke
	kljuc=ftok("prvi1.c",4);
	idreda1=msgget(kljuc, IPC_CREAT|0666);
	
	kljuc=ftok("prvi1.c",5);
	idreda2=msgget(kljuc, IPC_CREAT|0666);
	
	
	//kreiranje deljene memorije
	kljuc=ftok("prvi1.c",2);
	shmid1=shmget(kljuc, SHM_SIZE*sizeof(int), 0644|IPC_CREAT); 
	tk=shmat(shmid1, NULL, 0);
	
	kljuc=ftok("prvi1.c",3);
	shmid2=shmget(kljuc, SHM_SIZE*sizeof(int), 0644|IPC_CREAT); 
	tz=shmat(shmid2, NULL, 0);
	
	
	//kreiranje semafora 
	kljuc=ftok("zad.c",1);
	semid=semget(kljuc, 4, 0644|IPC_CREAT|IPC_EXCL); 
	
	if(semid!=-1)
	{
		//inicijal. semafora
		opNadSemaforom.val=1;
		semctl(semid, 0, SETVAL, opNadSemaforom);
		opNadSemaforom.val=0;
		semctl(semid, 1, SETVAL, opNadSemaforom);
		opNadSemaforom.val=0;
		semctl(semid, 2, SETVAL, opNadSemaforom);
		opNadSemaforom.val=0;
		semctl(semid, 3, SETVAL, opNadSemaforom);				
	}
	else if(errno==EEXIST)
	{
		semid=semget(kljuc, 4 ,0); 
	}	
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	//DEFINISANJE OP
	a1.sem_num=0;
	a1.sem_op=-1;
	a1.sem_flg=0;
	
	a2.sem_num=1;
	a2.sem_op=1;
	a2.sem_flg=0;
	
	a3.sem_num=2;
	a3.sem_op=1;
	a3.sem_flg=0;
	
	a4.sem_num=3;
	a4.sem_op=1;
	a4.sem_flg=0;
	
	
	//cekanje prijava od 4 igraca
	int ii;
	for(ii=0;ii<4;ii++)
	{
		msgrcv(idreda1,&p, sizeof(p),5,0);//sacekace da primi poruku tipa 5 dok se ona ne pojavi
		printf("PRIMLJENO %d prijava!\n",ii+1);
	}
	//igra krece kad se prijavi 4 igraca 
	printf("\nPOCINJE IGRA PRIJAVILA SU SE 4 IGRACA\n");
	
	pid_t pid, pidd;
	pid=fork();
	if(pid==0)
	{
		int id=0;
		for(ii=0;ii<4;ii++)
		{
			i.tip=1;
			i.id=id++;
			msgsnd(idreda2, &i, sizeof(i),0);
		}
	}
	else if(pid!=-1)
	{
		//TALON
		sleep(4);
		int tak, taz;
		
		tak=rand()%14;
		if(tak==0) tak=14;
		
		taz=rand()%4;
		
		(*tk)=tak;
		(*tz)=taz;
	}	
	return 0;
}
