#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

int semid;
int shmid1, shmid2;
int idreda1, idreda2;

int *tk; //TALON KARTA
int *tz;  //TALON ZNAK

struct prijavaa
{
long tip; // tip poruke
int prijava; // tekst poruke
};

 struct igra
{
long tip; // tip poruke
int id; // tekst poruke
};


union semun {
int val;
/*used for SETVAL only */

struct semid_ds *buf; /* used for IPC_STAT and IPC_SET */

ushort *array;
/* used for GETALL and SETALL */
 };
 
 
void izbrisiSemafore(int sig)
{
	printf("\nKRAJ\n");
	semctl(semid, 0, IPC_RMID); //brisanje sem
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	
	shmdt(tk); 				//brisanje mem
	shmdt(tz);
	shmctl(shmid1, IPC_RMID, NULL);
	shmctl(shmid2, IPC_RMID, NULL);
	
	exit(0);
}

int main()
{
	
	struct prijavaa p;
	struct igra i;
	srand(time(NULL));
	signal(SIGINT, izbrisiSemafore);
	key_t kljuc;
	union semun opNadSemaforom;
	struct sembuf a1,a2,a3,a4; 
	
	//kreiranje deljene memorije
	kljuc=ftok("prvi1.c",2);
	shmid1=shmget(kljuc, SHM_SIZE*sizeof(int), 0644|IPC_CREAT); 
	tk=shmat(shmid1, NULL, 0);
	
	kljuc=ftok("prvi1.c",3);
	shmid2=shmget(kljuc, SHM_SIZE*sizeof(int), 0644|IPC_CREAT); 
	tz=shmat(shmid2, NULL, 0);
	
	//kreiranje reda za poruke
	kljuc=ftok("prvi1.c",4);
	idreda1=msgget(kljuc, IPC_CREAT|0666);
	
	kljuc=ftok("prvi1.c",5);
	idreda2=msgget(kljuc, IPC_CREAT|0666);
	
	//kreiranje semafora 
	kljuc=ftok("zad.c",1);
	semid=semget(kljuc, 4, 0644|IPC_CREAT|IPC_EXCL); 
	
	if(semid!=-1)
	{
		//inicijal. semafora
		opNadSemaforom.val=1;
		semctl(semid, 0, SETVAL, opNadSemaforom);
		opNadSemaforom.val=0;
		semctl(semid, 1, SETVAL, opNadSemaforom);
		opNadSemaforom.val=0;
		semctl(semid, 2, SETVAL, opNadSemaforom);
		opNadSemaforom.val=0;
		semctl(semid, 3, SETVAL, opNadSemaforom);				
	}
	else if(errno==EEXIST)
	{
		semid=semget(kljuc, 4 ,0); 
	}	
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	a1.sem_num=0;
	a1.sem_op=1;
	a1.sem_flg=0;
	
	a2.sem_num=1;
	a2.sem_op=1;
	a2.sem_flg=0;
	
	a3.sem_num=2;
	a3.sem_op=-1;
	a3.sem_flg=0;
	
	a4.sem_num=3;
	a4.sem_op=1;
	a4.sem_flg=0;
	
	//TALON
	int tak, taz;
	
	tak=rand()%14;
	if(tak==0) tak=14;
	
	taz=rand()%4;
	
	(*tk)=tak;
	(*tz)=taz;
	
	//prijava
	p.tip=5;
	p.prijava=1;
	msgsnd(idreda1, &p, sizeof(p),0);
	//ceka odobrenje 
	msgrcv(idreda2, &i, sizeof(i),1,0);
	
	
	
	
	//IGRA
	int ind, karta, znak, pom;
	while(1)
	{
		pom=0;
		
		ind=semop(semid, &a3 , 1);
		if(ind==-1) break;
		
		//KARTA
		karta=rand()%14;
		if(karta==0) karta=14;
		//ZNAK  0=pik 1=karo 2=tref 3=herc
		znak=rand()%4;
		
		sleep(1);
		
		//poklapanje karata
		if((*tk)==karta || (*tz)==znak)
		{
			printf("IGRAC 3 : kartu %d %d sam poklopio kartom %d %d\n", *tk, *tz, karta, znak);
			(*tk)=karta;
			(*tz)=znak;
			pom=karta;
		}
		else
		{
			printf("Nemam adekvatnu kartu.\n");
		}
		if(pom==8) 
			ind=semop(semid, &a2 , 1); //unazad igra
		else	
			ind=semop(semid, &a4 , 1); 
		if(ind==-1) break;
	}
	
	return 0;
}
