#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

struct karta{
	int broj;
	int znak;
	int osmica;
};

void izbrisiSemafor(int sig)
{
	printf("Brisem semafore\n");
	semctl(semid,0,IPC_RMID);
	semctl(semid,1,IPC_RMID);
	semctl(semid,2,IPC_RMID);
	semctl(semid,3,IPC_RMID);
	
	printf("Zavrsavam\n");
	exit(0);
}

int main()
{
	srand(time(NULL));
	key_t key;
	int shmid;
	struct karta *spil;
	struct karta kartica;
	
	struct sembuf P,V1,V2;
	union semun operacija_nad_sem;
	
	signal(SIGINT,izbrisiSemafor);
	
	key=ftok("./igrac1.c",'R');
	shmid=shmget(key,sizeof(struct karta),0666|IPC_CREAT);
	spil=(struct karta *)shmat(shmid,(void*)0,0);
	key=ftok("./igrac1.c",'A');
	semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{		
		printf("Ja kreiram semafor\n");
		kartica.broj=((rand()%14))+1;
		kartica.znak=((rand()%4))+1;
		kartica.osmica=0;
		if(kartica.znak==1)
			printf("Prva kartica u spilu je: %d karo\n",kartica.broj);
		if(kartica.znak==2)
			printf("Prva kartica u spilu je: %d pik\n",kartica.broj);
		if(kartica.znak==3)
			printf("Prva kartica u spilu je: %d tref\n",kartica.broj);
		if(kartica.znak==4)
			printf("Prva kartica u spilu je: %d herc\n",kartica.broj);
		sleep(5);
		operacija_nad_sem.val=1;
		semctl(semid,0,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,1,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,2,SETVAL,operacija_nad_sem);
		operacija_nad_sem.val=0;
		semctl(semid,3,SETVAL,operacija_nad_sem);
	}
	else if(errno==EEXIST)
	{
		printf("Neko drugi je napravio semafor, ja se samo kacim\n");
		semid=semget(key,4,0);
	}
	else
	{
		printf("Neka druga greska!\n");
		exit(0);
	}
	
	P.sem_num=2;
	P.sem_op=-1;
	P.sem_flg=0;
	
	V1.sem_num=3;
	V1.sem_op=1;
	V1.sem_flg=0;
	
	V2.sem_num=1;
	V2.sem_op=1;
	V2.sem_flg=0;
	
	*spil=kartica;
	(*spil).osmica=0;
	while(1)
	{	
		if((*spil).broj==8)
		{
			printf("\n\nMenjam smer!\n\n");
			
			if((*spil).osmica==0)
				(*spil).osmica=1;
			else
				(*spil).osmica=0;
			sleep(5);
		}	
		semop(semid,&P,1);
		if((*spil).osmica==0)
		{
			
			
			kartica.broj=((rand()%14))+1;
			kartica.znak=((rand()%4))+1;
			if(kartica.znak==1)
				printf("Igrac 3 je izvukao karticu %d karo\n",kartica.broj);
			if(kartica.znak==2)
				printf("Igrac 3 je izvukao karticu %d pik\n",kartica.broj);
			if(kartica.znak==3)
				printf("Igrac 3 je izvukao karticu %d tref\n",kartica.broj);
			if(kartica.znak==4)
				printf("Igrac 3 je izvukao karticu %d herc\n",kartica.broj);
			
			if((*spil).broj==kartica.broj || (*spil).znak==kartica.znak)
			{
				*spil=kartica;
				printf("Kartica je zamenjena\n");
			}
			else
				printf("Kartica nije zamenjena\n");
			sleep(5);
			semop(semid,&V1,1);
		}
		else
		{
			kartica.broj=((rand()%14))+1;
			kartica.znak=((rand()%4))+1;
			if(kartica.znak==1)
				printf("Igrac 3 je izvukao karticu %d karo\n",kartica.broj);
			if(kartica.znak==2)
				printf("Igrac 3 je izvukao karticu %d pik\n",kartica.broj);
			if(kartica.znak==3)
				printf("Igrac 3 je izvukao karticu %d tref\n",kartica.broj);
			if(kartica.znak==4)
				printf("Igrac 3 je izvukao karticu %d herc\n",kartica.broj);
			
			if((*spil).broj==kartica.broj || (*spil).znak==kartica.znak)
			{
				*spil=kartica;
				printf("Kartica je zamenjena\n");
			}
			else
				printf("Kartica nije zamenjena\n");
			
			sleep(5);
	
			semop(semid,&V2,1);
		}
		
	}	
}
