#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

int semid;
int shmid1;
int shmid2;
int *data_broj;
int *data_znak;

union semun{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

void sigint_handler(int sig){
	printf("CTRL + C\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	shmdt(data_broj);
	shmdt(data_znak);
	shmctl(shmid1, IPC_RMID, NULL);
	shmctl(shmid2, IPC_RMID, NULL);
	exit(0);
}

int main(){
	
	srand(time(NULL));
	signal(SIGINT,sigint_handler);
	
	key_t kljuc1;
	key_t kljuc2;
	key_t kljuc3;
	union semun arg;
	struct sembuf P, V;
	int *data_broj;
	int *data_znak;
	int pombroj;
	int pomznak;
	
	kljuc1 = ftok("./igrac1.c",16);
	printf("Kljuc 1: %d\n",kljuc1);
	
	kljuc2 = ftok("./igrac1.c",2);
	printf("Kljuc 2: %d\n",kljuc2);
	
	kljuc3 = ftok("./igrac1.c",98);
	printf("Kljuc 3: %d\n",kljuc3);
	
	shmid1 = shmget(kljuc1, sizeof(int), 0666|IPC_CREAT);
	printf("ID memorije 1: %d\n",shmid1);
	
	shmid2 = shmget(kljuc2, sizeof(int), 0666|IPC_CREAT);
	printf("ID memorije 2: %d\n",shmid2);
	
	semid = semget(kljuc3, 4, 0666|IPC_CREAT|IPC_EXCL);
	printf("ID semafora: %d\n",semid);
	
	if( semid!= -1 ){
		printf("Pravim semafor\n");
		arg.val = 1;
		semctl(semid, 0, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 1, SETVAL, arg);
		semctl(semid, 2, SETVAL, arg);
		semctl(semid, 3, SETVAL, arg);
	}
	else if(errno == EEXIST){
		printf("Kacim se na semafor\n");
		semid = semget(kljuc3, 4, 0);
	}
	/*
	pombroj = rand() % 14;		//0-13
	pombroj++;					//1-14
	pomznak = rand() % 4;		//0-3
	pomznak++;					//1-4
	*/
	data_broj = (int*)shmat(shmid1, NULL, 0);
	data_znak = (int*)shmat(shmid2, NULL, 0);
	
	//*data_broj = pombroj;
	//*data_znak = pomznak;
	
	P.sem_num = 1;
	P.sem_op = -1;
	P.sem_flg = 0;
	
	V.sem_num = 2;
	V.sem_op = 1;
	V.sem_flg = 0;
	
	while(1602){
		
		if( (semop(semid,&P,1)) == -1 )		break;
		pombroj = rand() % 14;
		pombroj++;
		pomznak = rand() % 4;
		pomznak++;
		if(*data_znak == 1){
			printf("Na talonu: %d karo\n",*data_broj);
			sleep(1);
		}
		else if(*data_znak == 2){
			printf("Na talonu: %d herc\n",*data_broj);
			sleep(1);
		}
		else if(*data_znak == 3){
			printf("Na talonu: %d tref\n",*data_broj);
			sleep(1);
		}
		else{
			printf("Na talonu: %d pik\n",*data_broj);
			sleep(1);
		}
		if(pomznak == 1){
			printf("Izvukao sam: %d karo\n",pombroj);
			sleep(1);
		}
		else if(pomznak == 2){
			printf("Izvukao sam: %d herc\n",pombroj);
			sleep(1);
		}
		else if(pomznak == 3){
			printf("Izvukao sam: %d tref\n",pombroj);
			sleep(1);
		}
		else{
			printf("Izvukao sam: %d pik\n",pombroj);
			sleep(1);
		}
		if(pomznak == *data_znak || pombroj == *data_broj){
			sleep(1);
			printf("Imam adekvatnu kartu, poklapam\n");
			*data_znak = pomznak;
			*data_broj = pombroj;
			sleep(1);
		}
		else{
			sleep(1);
			printf("Nemam adekvatnu kartu\n");
			sleep(1);
		}
		if( (semop(semid,&V,1)) == -1 )		break;
	}
	
	return 0;
}
