#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define KARO 0
#define PIK 1
#define TREF 2
#define HERC 3

#define NORMALANSMER 0
#define OBRNUTISMER 1

union semun
{
	int val;
	ushort *array;
	struct semid_ds *buf;
};

struct Karta
{
	int broj;
	int znak;
	int smer;
};

int main()
{
	srand(time(NULL));
	
	union semun arg;
	struct sembuf TreciP,DrugiV ,CetvrtiV;
	
	struct Karta *karta;
	struct Karta pom;
	
	key_t key=ftok("./treci.c",'A');
	int shmid=shmget(key,1024,0666|IPC_CREAT);
	
	key=ftok("./treci.c",'B');
	int semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	
	if(semid!=-1)
	{
		arg.val=0;
		semctl(semid,0,SETVAL,arg);
		semctl(semid,1,SETVAL,arg);
		semctl(semid,2,SETVAL,arg);
		semctl(semid,3,SETVAL,arg);
	}
	else if(errno==EEXIST)
	{
		semid=semget(key,4,0);
	}
	else
	{
		printf("Greska\n");
		exit(0);
	}
	
	////////semafori
	
	TreciP.sem_num=2;
	TreciP.sem_op=-1;
	TreciP.sem_flg=0;
	
	DrugiV.sem_num=1;
	DrugiV.sem_op=+1;
	DrugiV.sem_flg=0;
	
	CetvrtiV.sem_num=3;
	CetvrtiV.sem_op=+1;
	CetvrtiV.sem_flg=0;
	
	karta=shmat(shmid,NULL,0);
	
	
	while(1)
	{
		
		semop(semid,&TreciP,1); //blokiraj 3
		
		pom.broj=rand()%14;
		pom.znak=rand()%4;
		
		printf("Broj: %d  Znak: %d\n",pom.broj,pom.znak);
		
		if(pom.znak==karta->znak || pom.broj==karta->broj)
		{
			karta->znak=pom.znak;
			karta->broj=pom.broj;
			
			if(karta->broj==8)
			{
				if(karta->smer==OBRNUTISMER)
					karta->smer=NORMALANSMER;
				else	
					karta->smer=OBRNUTISMER;
			}
		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
		}
		
		sleep(5);
		if(karta->smer==OBRNUTISMER)
		{
			semop(semid,&DrugiV,1); //igra 2
			printf("Obrnuti\n");
		}
		else 
		{
			semop(semid,&CetvrtiV,1); //igra 4
			printf("Normalan\n");
		}
	}
	
	shmdt(karta);
}
