#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun{
	
	int val;
	struct semid_ds *buf;
	ushort *array;	
};


int semid,shmid1,shmid2;

void handler(int sig)
{
		printf("Prekinut sa CTRL+C, brisem ipc objekte\n");
		semctl(semid,0,IPC_RMID);
		semctl(semid,1,IPC_RMID);
		semctl(semid,2,IPC_RMID);
		semctl(semid,3,IPC_RMID);
		shmctl(semid,IPC_RMID,NULL);
		exit(0);		
}


int main()
{
	key_t key;
	//int semid,shmid;
	int *broj,*znak;
	union semun arg;
	struct sembuf opP,opV,opV1,opV2;
	int mojaKartaBroj,mojaKartaZnak;
	
	signal(SIGINT,handler);
	key=ftok("./1.c",10);
	printf("Kljuc:%d\n\n",key);
	
	semid=semget(key,4,0666|IPC_CREAT|IPC_EXCL);
	printf("Id semafora:%d\n\n",semid);
	
	key=ftok("./init.c",20);
	printf("Kljuc:%d\n",key);
	
	shmid1=shmget(key,1024,0666|IPC_CREAT);
	printf("Id deljene memorije1:%d\n\n",shmid1);
	
		key=ftok("./init.c",30);
	printf("Kljuc:%d\n",key);
	
	shmid2=shmget(key,1024,0666|IPC_CREAT);
	printf("Id deljene memorije2:%d\n\n",shmid2);
	
	if(semid != -1)
	{
		printf("Uspesno napravljen semafor\n");
		arg.val=0;
		semctl(semid,0,SETVAL,arg);
		arg.val=0;
		semctl(semid,1,SETVAL,arg);
		arg.val=0;
		semctl(semid,2,SETVAL,arg);
		arg.val=0;
		semctl(semid,3,SETVAL,arg);
	}
	else if(errno==EEXIST)
	{
		printf("Povezivanje na semafor\n");
		semid=semget(key,4,0);
		
	}
	else
	{
		printf("Neka druga greska,zavrsavam\n");
		exit(0);
	}
	
	srand(time(NULL));
	
	opP.sem_num=1; //da se blokiram
	opP.sem_op=-1;
	opP.sem_flg=0;
	
	opV.sem_num=2; //da odblokira 3
	opV.sem_op=1;
	opV.sem_flg=0;
	
	opV1.sem_num=3;
	opV1.sem_op=1;
	opV1.sem_flg=0;
	
	opV2.sem_num=0;
	opV2.sem_op=1;
	opV2.sem_flg=0;
	
	
	while(1)
	{
		semop(semid,&opP,1); //ceka da ga prvi odblokira
		broj=shmat(shmid1,NULL,0);
		printf("Procitan broj na karti:%d\n",*broj);
		znak=shmat(shmid2,NULL,0);
		printf("Procitan znak na karti:%d\n",*znak);
		
		mojaKartaBroj=rand()%13;
		mojaKartaZnak=rand()%3;
		
		printf("Moja karta: broj:%d  znak:%d\n",mojaKartaBroj,mojaKartaZnak);
		
		if(mojaKartaBroj==*broj || mojaKartaZnak==*znak)
		{
			printf("Moja karta ide na talon\n\n");
			printf("--------------\n");
			*broj=mojaKartaBroj;
			*znak=mojaKartaZnak;
			
			} 
		else
		{  printf("Nemam adekvatnu kartu\n\n");	
			printf("--------------\n"); }
			
		semop(semid,&opV,1); //treci
		semop(semid,&opV1,1); //cetvrti
		semop(semid,&opV2,1); //prvi
		sleep(10);		
		
		
		
		}
	
	
	
	return 0;
	}

