#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union semun {
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

void sigHandler(int sig)
{
	printf("brisem sve semafore\n");
	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);
	printf("Obrisao sam sve semafore, sad se gasim\n");
	exit(0);
}

int main()
{
	key_t key,key2,key3;
	int shmid1,shmid2,shmidRedosled;
	pid_t pid;
	union semun arg;
	struct sembuf P,V;
	int *dataBroj;
	int *dataZnak;
	int *dataRedosled;

	int br = 0;

	srand(time(NULL));
	
	signal(SIGINT,sigHandler);

	key = ftok("1.igrac.c",'A');
	key2 = ftok("1.igrac.c",'C');
	key3 = ftok("1.igrac.c",'G');
	shmid1 = shmget(key,sizeof(int), 0666|IPC_CREAT);
	shmid2 = shmget(key2,sizeof(int), 0666|IPC_CREAT);
	shmidRedosled = shmget(key3,sizeof(int), 0666|IPC_CREAT);

	semid = semget(key,4,0666|IPC_CREAT|IPC_EXCL);

	if(semid != -1)
	{
		printf("Ja pravim semafor\n");
		arg.val = 1;
		semctl(semid, 0, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 1, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 2, SETVAL, arg);
		arg.val = 0;
		semctl(semid, 3, SETVAL, arg);

		dataBroj = (int*)shmat(shmid1, NULL, 0);
		dataZnak = (int*)shmat(shmid2, NULL, 0);
		dataRedosled = (int*)shmat(shmidRedosled, NULL, 0);

		*dataRedosled = 1;

		*dataBroj = (rand() % 14) + 1;
		*dataZnak = (rand() % 4) + 1;

		int broj = *dataBroj;
		if(broj==8)
		{
			*dataRedosled = *dataRedosled * -1;
		}


	}
	else if(errno == EEXIST)
	{
		printf("Neko je vec napravio semafor\n");
		semid = semget(key,4,0);
	}
	else
	{
		exit(0);
	}


	P.sem_num = 1;
	P.sem_op = -1;
	P.sem_flg = 0;

	V.sem_num = 2;
	V.sem_op = 1;
	V.sem_flg = 0;


	int brojNove,znakNove,ind;

	//printf("semid = %d\n",semid);
	

	while(1)
	{


		ind = semop(semid, &P, 1);
		if(ind==-1) break;


		br++;
		printf("---------------Moje %d. igranje-----------\n",br);

		brojNove = (rand() % 14) + 1;
		znakNove = (rand() % 4) + 1;

		dataBroj = (int*)shmat(shmid1, NULL, 0);
		dataZnak = (int*)shmat(shmid2, NULL, 0);
		dataRedosled = (int*)shmat(shmidRedosled, NULL, 0);

		printf("Trenutna karta na talonu je %d sa znamkom %d\n",*dataBroj,*dataZnak);
		printf("Moja karta je %d sa znakom %d\n",brojNove,znakNove);
		if(*dataBroj == brojNove || *dataZnak == znakNove)
		{
			*dataBroj = brojNove;
			*dataZnak = znakNove;

			if(*dataBroj == 8)
			{
				*dataRedosled = *dataRedosled * -1;
			}
			printf("Izbacujem kartu %d sa znakom %d\n",*dataBroj,*dataZnak);

		}
		else
		{
			printf("Nemam adekvatnu kartu\n");
		}


		if(*dataRedosled == 1)
		{
			V.sem_num = 2;
			V.sem_op = 1;
			V.sem_flg = 0;
			printf("Redosled je normalan %d\n",*dataRedosled);
			printf("dajem sledecem da on igra\n");
		}
		else
		{
			V.sem_num = 0;
			V.sem_op = 1;
			V.sem_flg = 0;
			printf("Redosled je obrnut %d\n",*dataRedosled);
			printf("dajem prethodnom da on igra\n");
		}

		sleep(1);

		ind = semop(semid, &V, 1);
		if(ind==-1) break;
		//sleep(3);

	}	

}