#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1

union semun{
    int val;
    struct semid_ds *buf;
    ushort *array;
};

struct Karta{
	int broj;
	int boja;
};

struct igra{
	struct Karta karta;
	int smer;
};

int main(){

	key_t key;
	int semid, shmid;
	union semun arg;
	int i;

	srand(time(NULL));

	key = ftok("Igrac1.c", 'R');
    printf("Kljuc je: %d\n", key);

    if (semid == -1){
        printf("Semafor nije inicijalizovan.\n");

        semid = semget(key, 4, 0644|IPC_CREAT);
        printf("Semafor id: %d\n", semid);

        arg.val = 1;
        semctl(semid, 0, SETVAL, arg);

        arg.val = 0;
        for (i=1; i<4; i++)
            semctl(semid, i, SETVAL, arg);
    }
    else{
		
		semid = semget(key, 4, 0644|IPC_CREAT);
        
        
        printf("Neko je vec inicijalizovao semafore: %d\n", semid);
    }
    
    shmid = shmget(key, SHM_SIZE*sizeof(struct igra), 0644|IPC_CREAT);
    printf("ID deljene memorije: %d\n", shmid);
    
    struct igra *data;
    
    data = (struct igra *)shmat(shmid, NULL, 0);

    struct sembuf P, V;

    P.sem_num = 1;
    P.sem_op = -1;
    P.sem_flg = 0;

    V.sem_num = 2;
    V.sem_op = 1;
    V.sem_flg = 0;


	struct Karta karta;

	while (1){

        semop(semid, &P, 1);
        
        sleep(3);
        
        karta.broj = 1 + rand()%14; 
        karta.boja = rand()%4;
        
        if (karta.broj == data->karta.broj || karta.boja == data->karta.boja){
			printf("Igrac 2 je izbacio kartu %d %d preko karte %d %d\n", karta.broj, karta.boja, data->karta.broj, data->karta.boja);
			data->karta = karta;
			if (karta.broj == 8) data->smer *= -1;
		}
		else{
			printf("Nemam adekvatnu kartu\n");
			printf("Karta na stolu %d %d a ja imam %d %d\n", data->karta.broj, data->karta.boja, karta.broj, karta.boja);
        }
        
        V.sem_num = (P.sem_num + data->smer) % 4;

        semop(semid, &V, 1);

    }
    
    shmdt(data);

	return 0;
}

