#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

typedef union sem_un{
	int val;
	struct idsem_ds *buf;
	ushort *array;
}sem_un;

int main(){
	// rng
	srand(time(0));
	
	//inicijalizacija deljene memorije
	key_t key = ftok("server.c", 1);
	int shm_id = shmget(key, 1024, 0644 | IPC_CREAT);
	int *niz = shmat(shm_id, NULL, 0);
	*niz = 3;
	*(niz + 1) = 1;
	*(niz + 2) = 0;
	
	// inicijalizacija kontrolnog semafora
	key = ftok("server.c", 2);
	int sem_id_ctl = semget(key, 3, 0644 | IPC_CREAT);
	
	sem_un sem_in;
	sem_in.val = 0;
	semctl(sem_id_ctl, 0, SETVAL, sem_in);
	semctl(sem_id_ctl, 1, SETVAL, sem_in);
	sem_in.val = 1;
	semctl(sem_id_ctl, 2, SETVAL, sem_in);
	
	// server
	struct sembuf sem;
	sem.sem_flg = 0;
	while(1){
		sem.sem_num = 0;
		sem.sem_op = -4;
		semop(sem_id_ctl, &sem, 1);
		
		if(!fork()){
			//inicijalizacija igre
			key = ftok("server.c", niz[0]);
			int sem_id_game = semget(key, 5, 0644 | IPC_CREAT);
			
			sem_in.array = (ushort *)malloc(5 * sizeof(ushort));
			sem_in.array[0] = sem_in.array[1] = sem_in.array[2] = sem_in.array[3] = sem_in.array[4] = 0;
			semctl(sem_id_game, 0, SETALL, sem_in);
			
			key = ftok("igrac.c", niz[1]);
			int shm_id_game = shmget(key, 1024, 0644 | IPC_CREAT);
			
			int *top = shmat(shm_id_game, NULL, 0);
			top[0] = rand() % 13 + 1;
			top[1] = rand() % 4; // znak na karti
			if(top[0] == 8)
				top[2] = -1;
			else
				top[2] = 1;
						
			sem.sem_num = 1;
			sem.sem_op = 4;
			semop(sem_id_ctl, &sem, 1);
			
			// igra
			int i;
			for(i = 0 ; i < 6 ; i++){
				if(top[2] == 1)
					sem.sem_num = 1;
				else
					sem.sem_num = 4;
				sem.sem_op = 1;
				semop(sem_id_game, &sem, 1);
				
				sem.sem_num = 0;
				sem.sem_op = -1;
				semop(sem_id_game, &sem, 1);
			}
			
			// igra je zavrsena, brisanje redova
			semctl(sem_id_game, 0, IPC_RMID);
			semctl(sem_id_game, 1, IPC_RMID);
			semctl(sem_id_game, 2, IPC_RMID);
			semctl(sem_id_game, 3, IPC_RMID);
			semctl(sem_id_game, 4, IPC_RMID);
			shmctl(shm_id_game, 0, NULL);
		}
		
		sem.sem_num = 2;
		sem.sem_op = -4;
		semop(sem_id_ctl, &sem, 1);
		
		niz[0]++;
		niz[1]++;
	}
	
	return 0;
}
