#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024

union semun {
	int val;
	struct semid_ds *buf; 
	ushort *array;
};
int semid, shmid;
int *podaci;

void izbrisiSve(int sig){
	printf("\nUhvacen signal\n");
	semctl(semid, 0, IPC_RMID);	
	semctl(semid, 1, IPC_RMID);	
	semctl(semid, 2, IPC_RMID);	
	semctl(semid, 3, IPC_RMID);
	semctl(semid, 4, IPC_RMID);
	semctl(semid, 5, IPC_RMID);
	semctl(semid, 6, IPC_RMID);
	shmdt(podaci);
	shmctl(shmid, IPC_RMID, NULL);
	exit(0);
}

int main(){
	key_t kljuc;
	union semun operacija;
	struct sembuf sem1, sem2, sem4, semMemS, semMemP, serverPovecaj;
	signal(SIGINT, izbrisiSve);
	
	kljuc = ftok("igrac1.c", 10);
	shmid = shmget(kljuc, sizeof(int)*SHM_SIZE, 0666|IPC_CREAT);
	podaci = shmat(shmid, NULL, 0);
	
	kljuc = ftok("igrac1.c", 12);
	semid = semget(kljuc, 7, 0666|IPC_CREAT|IPC_EXCL);
	srand(time(NULL));
	if(semid != -1)
	{
		printf("kreiram semafor\n");
		operacija.val = 1;
		semctl(semid, 4, SETVAL, operacija);
		operacija.val = 0;
		semctl(semid, 0, SETVAL, operacija);
		semctl(semid, 1, SETVAL, operacija);
		semctl(semid, 2, SETVAL, operacija);
		semctl(semid, 3, SETVAL, operacija);
		semctl(semid, 5, SETVAL, operacija);
		semctl(semid, 6, SETVAL, operacija);		
	}
	else if(errno == EEXIST)
	{
		printf("kacim se\n");
		semid = semget(kljuc, 7, 0);
	}
	else
	{
		printf("neka druga greska\n");
		exit(0);
	}
	/*
		0 prvi igrac
		1 drugi igrac
		2 treci igrac
		3 cetvrti igrac
		4 kontrola pristupa deljenoj memoriji
		5 pocetak partije
		6 server
	*/
	sem1.sem_num = 0;
	sem1.sem_op = -1;
	sem1.sem_flg = 0;
	
	sem2.sem_num = 1;
	sem2.sem_op = 1;
	sem2.sem_flg = 0;
	
	sem4.sem_num = 3;
	sem4.sem_op = 1;
	sem4.sem_flg = 0;
	
	semMemP.sem_num = 4;
	semMemP.sem_op = 1;
	semMemP.sem_flg = 0;

	semMemS.sem_num = 4;
	semMemS.sem_op = -1;
	semMemS.sem_flg = 0;

	serverPovecaj.sem_num = 6;
	serverPovecaj.sem_op = 1;
	serverPovecaj.sem_flg = 0;
	
	//inicijalizacija deljene memorije
	podaci[0] = rand()%14 + 1; //karta na talonu
	podaci[1] = rand()%4; //znak karte- 0 pik, 1 herc, 2 karo, 3 tref
	if(podaci[0] == 8)
		podaci[2] = 1; // 0 na desno, 1 na levo
	else
		podaci[2] = 0;
	int i, ind, karta, znak;
	
	ind = semop(semid, &serverPovecaj, 1);
	if(ind == -1)
		exit(0);
	while(1)
	{
		ind = semop(semid, &sem1, 1);
		printf("NA TALONU %d znak %d\n", podaci[0], podaci[1]);
		if(ind == -1)
			break;
		sleep(1);
		karta = rand()%14 + 1;
		znak = rand()%4;
		printf("izvukao sam %d znak %d\n", karta, znak);
		
		//rad s deljenom
		ind = semop(semid, &semMemS, 1);
		if(ind == -1)
			break;
		if(podaci[1] == znak || podaci[0] == karta)
		{
				printf("odigran potez\n");
				podaci[0] = karta;
				podaci[1] = znak;
				if(podaci[0] == 8)
				{
					if(podaci[2] == 1)
						podaci[2] = 0;
					else
						podaci[2] = 1;
				}
		}	
		else
			printf("Nemam adekvatnu kartu\n");
		ind = semop(semid, &semMemP, 1);	
		sleep(2);
		printf("\n\n");
		if(podaci[2] == 0)
		{
			ind = semop(semid, &sem2, 1);
			if(ind == -1)
				break;		
		}
		else
		{
			ind = semop(semid, &sem4, 1);
			if(ind == -1)
				break;
		}
	}
	printf("igrac 1 je zavrsio\n");
	return 0;
}
