#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define SHM_SIZE 1024

union semun {
	int val;
	struct semid_ds *buf; 
	ushort *array;
};
int semid, shmid;
int *podaci;

void izbrisiSve(int sig){
	printf("\nUhvacen signal\n");
	semctl(semid, 0, IPC_RMID);	
	semctl(semid, 1, IPC_RMID);	
	semctl(semid, 2, IPC_RMID);	
	semctl(semid, 3, IPC_RMID);
	semctl(semid, 4, IPC_RMID);
	semctl(semid, 5, IPC_RMID);
	semctl(semid, 6, IPC_RMID);
	shmdt(podaci);
	shmctl(shmid, IPC_RMID, NULL);
	exit(0);
}

int main(){
	key_t kljuc;
	union semun operacija;
	struct sembuf sem1, deteSmanji, detePovecaj, serverSmanji;
	signal(SIGINT, izbrisiSve);
	
	kljuc = ftok("igrac1.c", 10);
	shmid = shmget(kljuc, sizeof(int)*SHM_SIZE, 0666|IPC_CREAT);
	podaci = shmat(shmid, NULL, 0);
	
	kljuc = ftok("igrac1.c", 12);
	semid = semget(kljuc, 7, 0666|IPC_CREAT|IPC_EXCL);
	srand(time(NULL));
	if(semid != -1)
	{
		printf("kreiram semafor\n");
		operacija.val = 1;
		semctl(semid, 4, SETVAL, operacija);
		operacija.val = 0;
		semctl(semid, 0, SETVAL, operacija);
		semctl(semid, 1, SETVAL, operacija);
		semctl(semid, 2, SETVAL, operacija);
		semctl(semid, 3, SETVAL, operacija);
		semctl(semid, 5, SETVAL, operacija);
		semctl(semid, 6, SETVAL, operacija);		
	}
	else if(errno == EEXIST)
	{
		printf("kacim se\n");
		semid = semget(kljuc, 7, 0);
	}
	else
	{
		printf("neka druga greska\n");
		exit(0);
	}
	/*
		0 prvi igrac
		1 drugi igrac
		2 treci igrac
		3 cetvrti igrac
		4 kontrola pristupa deljenoj memoriji
		5 pocetak partije
		6 server
	*/
	sem1.sem_num = 0;
	sem1.sem_op = 1;
	sem1.sem_flg = 0;

	deteSmanji.sem_num = 5;
	deteSmanji.sem_op = -1;
	deteSmanji.sem_flg = 0;

	detePovecaj.sem_num = 5;
	detePovecaj.sem_op = 1;
	detePovecaj.sem_flg = 0;

	serverSmanji.sem_num = 6;
	serverSmanji.sem_op = -4;
	serverSmanji.sem_flg = 0;

	int p, ind;
	p = fork();
	while(1)
	{
		if(p == 0) //dete 
		{
			ind = semop(semid, &deteSmanji, 1);
			if(ind == -1)
				exit(0);
			printf("pocinje partija\n");
			ind = semop(semid, &sem1, 1);
			if(ind == -1)
				exit(0);
		}
		else //roditelj
		{
			printf("cekam igrace...\n");
			ind = semop(semid, &serverSmanji, 1);
			if(ind == -1)
			{
//				kill(p, SIGINT);
				exit(0);
			}
			ind = semop(semid, &detePovecaj, 1);
			if(ind == -1)
			{
//				kill(p, SIGINT);
				exit(0);
			}
		}
	}
	return 0;
}
