#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

#define KARO 1
#define PIK 2
#define TREF 3
#define HERC 4
#define NIJE -1
#define JESTE 0

union semun{
    int val;
    struct semid_ds *buf;
    ushort *array;
};

int shmid, *data, semid;

void signal_handler(int brSignala)
{
   shmctl(shmid, IPC_RMID, NULL);
   semctl(semid, 0, IPC_RMID);
   semctl(semid, 1, IPC_RMID);
   semctl(semid, 2, IPC_RMID);
   semctl(semid, 3, IPC_RMID);
   printf("Uklonio sam sve semafore, usled prekida signalom ..\n");
}

void znakJe(int br)
{
    if(br == 1)
        printf("KARO\n");
    if(br == 2)
        printf("PIK\n");
    if(br == 3)
        printf("TREF\n");
    if(br == 4)
         printf("HERC\n");
}

int main()
{

    signal(SIGINT, signal_handler); //zbog testiranja zadatka
    key_t kljuc;
    srand(time(NULL));
    struct sembuf P1, V1, V2;
    union semun sem_promenljiva;
    int n = 6;
    int ind;
    int broj, znak;

    kljuc = ftok("./igrac1.c", 45);
    printf("Kljuc: %d\n", kljuc);

    shmid = shmget(kljuc, sizeof(int) * 2, IPC_CREAT | IPC_EXCL | 0644);
    printf("Segment: %d\n", shmid);

    if(shmid != -1)
    {
        printf("Segment nije kreiran.. Ja ga kreiram ..\n");
        data= shmat(shmid, NULL, 0);
        data = shmat(shmid, NULL, 0);
        data[0] = rand() % 14;
        data[0] = data[0] + 1;
        data[1] = rand() % 4;
        data[1] = data[1] + 1;
        data[2] = NIJE;
        printf("Na talonu je karta %d u znaku ", data[0]);
        znakJe(data[1]);
     
    }
    else if(errno == EEXIST)
    {
        printf("Segment je vec kreiran, samo se povezujem ..\n");
        shmid = shmget(kljuc, sizeof(int) * 2, 0);
        data = shmat(shmid, NULL, 0);
    }
    else
    {
        printf("Greska ..\n");
        exit(0);
    }

    kljuc = ftok("./igrac1.c", 49);
    printf("Kljuc: %d\n", kljuc);

    semid = semget(kljuc, 4, 0644 | IPC_CREAT | IPC_EXCL);
    printf("Id sekupa semafora: %d\n", semid);

    if(semid != -1)
    {
        printf("Semafor nije kreiran.. Ja ga kreiram ..\n");
        sem_promenljiva.val = 1;
        semctl(semid, 0, SETVAL, sem_promenljiva); //semafor za igraca1
        sem_promenljiva.val = 0;
        semctl(semid, 1, SETVAL, sem_promenljiva); //semafor za igraca2
        semctl(semid, 2, SETVAL, sem_promenljiva); //semafor za igraca3
        semctl(semid, 3, SETVAL, sem_promenljiva); //semafor za igraca4

    }
    else if(errno == EEXIST)
    {
        printf("Skup semafora je vec kreiran .. Povezujem se na postojece semafore ..\n");
        semid = semget(kljuc, 4, 0);
    }

    P1.sem_num = 1;
    P1.sem_op = -1;
    P1.sem_flg = 0;

    V1.sem_num = 2;
    V1.sem_op = 1;
    V1.sem_flg = 0;

    V2.sem_num = 0;
    V2.sem_op = 1;
    V2.sem_flg = 0;

    printf("\n--------------------------------------------------------\n");
    while(1)
    {
        ind = semop(semid, &P1, 1);
        if(ind == -1)
            break;
        broj = rand() % 14;
        broj++;
        znak = rand() %4;
        znak++;
        printf("Na talonu je: %d ", data[0]); 
        znakJe(data[1]);

        printf("Izvucena je karta %d u znaku ", broj);
        znakJe(znak);
        
        if(broj == data[0] || znak == data[1])
        {
            data[0] = broj;
            data[1] = znak;
            if(data[0] == 8 && data[2] == NIJE)
            {
                data[2] = JESTE;
            }
            else if(data[0] == 8 && data[2] == JESTE)
            {
                data[2] = NIJE;
            }
        }
        else
            printf("Nemam adekvatnu kartu ..\n");
        
        sleep(4);
   
        
        printf("Sada je na talonu karta %d u znaku ", data[0]);
        znakJe(data[1]);

        if(data[2] == JESTE)
        {
            printf("\n redoled promenjen\n");
            ind = semop(semid, &V2, 1);
             if(ind == -1)
                break;
        }
        else if(data[2] == NIJE)
        {
            ind = semop(semid, &V1, 1);
            if(ind == -1)
                break;
        }
        printf("\n--------------------------------------------------------\n");
    }

    shmdt(data);


    return 0;
}