#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

union Unija{
	int val;
	struct semid_ds *buf;
	ushort *array;
};

int semid;

typedef struct data_s{
	int broj, smer;
	char znak[6];
}data;

void SignalH(int sig)
{
	printf("\nUhvacen SIGINT, brisem semafore\nZavrsavam..\n");

	semctl(semid, 0, IPC_RMID);
	semctl(semid, 1, IPC_RMID);
	semctl(semid, 2, IPC_RMID);
	semctl(semid, 3, IPC_RMID);

	exit(0);
}

void main()
{
	srand(time(NULL));

	key_t key;
	int shmid, ind, i, br, karta;
	char z[6];

	union Unija operacija_nad_sem;

	signal(SIGINT, SignalH);

	key = ftok("prvi1.c", 'D');
	shmid = shmget(key, sizeof(int), 0666|IPC_CREAT);
	semid = semget(key, 4, 0666|IPC_CREAT|IPC_EXCL);

	//Karta na talonu;
	data *k;
	k = shmat(shmid, (void *)0, 0);

	printf("Karta na talonu je: %d %s.\n\n", k->broj, k->znak);
	//////////////


	if(semid != -1)
	{
		printf("Pravim semafor.\n");

		operacija_nad_sem.val = 1;
		semctl(semid, 0, SETVAL, operacija_nad_sem);

		operacija_nad_sem.val = 0;
		semctl(semid, 1, SETVAL, operacija_nad_sem);

		operacija_nad_sem.val = 0;
		semctl(semid, 2, SETVAL, operacija_nad_sem);

		operacija_nad_sem.val = 0;
		semctl(semid, 3, SETVAL, operacija_nad_sem);
	}
	else if(errno == EEXIST)
	{
		printf("Semafori su vec kreirani, povezujem se.\n");
		semid = semget(key, 4, 0);
	}
	else
	{
		printf("Doslo je do greske.\nZavrsavam...\n");
		exit(0);
	}

	

	//OPERACIJE:
	/*
		igrac 1 - '0' semafor,
		igrac 2 - '1' semafor,
		igrac 3 - '2' semafor,
		igrac 4 - '3' semafor;
	*/
	struct sembuf op_pi1;
	struct sembuf op_vi2;

	op_pi1.sem_num = 3;	
	op_pi1.sem_op = -1;
	op_pi1.sem_flg = 0;

	op_vi2.sem_num = 0;	
	op_vi2.sem_op = 1;
	op_vi2.sem_flg = 0;


	printf("Stavljeno je sleep(2) kada dobije jednu kartu.\n\n");
	while(1)
	{
		karta = rand() % 14;
		++karta;
		br = rand() % 4;
		if(br == 0)
			strcpy(z, "karo");
		else if(br == 1)
			strcpy(z, "pik");
		else if(br == 2)
			strcpy(z, "tref");
		else
			strcpy(z, "herc");

		ind = semop(semid, &op_pi1, 1);
		
		printf("Karta na talonu je: %d %s.\n", k->broj, k->znak);
		printf("Dobijena karta: %d %s.\n", karta, z);
		if(karta == k->broj || (strcmp(z, k->znak) == 0))
		{
			k->broj = karta;
			strcpy(k->znak, z);

			printf("Poklapam kartu.\n");
		}
		else
			printf("Nemam adekvatnu kartu.\n");

		ind = semop(semid, &op_vi2, 1);

		putchar('\n');
		sleep(2);
	}
}
