#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>
#include <signal.h>
#include <time.h>
#include <sys/wait.h>
#include <errno.h>

/*
    0 - herc
    1 - pik
    2 - tref
    3 - karo
*/
int semid;

void signal_handler(int signal)
{
    semctl(semid, 0, IPC_RMID);
    semctl(semid, 1, IPC_RMID);
    semctl(semid, 2, IPC_RMID);
    semctl(semid, 3, IPC_RMID);

    printf("Obrisao sam semafore.\n");
    exit(1);
}

union semun
{
    int val;
    struct semid_ds *buf;
    ushort *array;
};


int main()
{
    signal(SIGINT, signal_handler);
    srand(time(NULL));

    key_t kljuc;
    union semun arg;
    struct sembuf P, V;
    int ind, r, i, n, z;
    int shmid, *talon;

    kljuc = ftok("./Igrac1.c", 2);
    semid = semget(kljuc, 4, 0644 | IPC_CREAT | IPC_EXCL);
    shmid = shmget(kljuc, 2*sizeof(int), 0666 | IPC_CREAT);

    talon = shmat(shmid, NULL, 0);

    if(semid != -1)
    {
        arg.val = 1;
        semctl(semid, 0, SETVAL, arg);
        arg.val = 0;
        semctl(semid, 1, SETVAL, arg);
        semctl(semid, 2, SETVAL, arg);
        semctl(semid, 3, SETVAL, arg);
        
        r = rand() % 14;
        z = rand() % 4;

        talon[0] = r;
        talon[1] = z;

        printf("Talon: %d %d\n", r, z);
    }
    else if(errno == EEXIST)
    {
        semid = semget(kljuc, 4, 0);
    }
    else
    {
        printf("Greska..\n");
        exit(1);
    }

    P.sem_num = 2;
    P.sem_op = -1;
    P.sem_flg = 0;

    V.sem_num = 3;
    V.sem_op = 1;
    V.sem_flg = 0;

    while(1)
    {
        ind = semop(semid, &P, 1);
        if(ind == -1) break;

        r = rand() % 14;
        z = rand() % 4;

        printf("%d %d\n", r, z);
        if(r == talon[0])
        {
            talon[1] = z;
            printf("Preklopio sam.\n");
        }
        else if(z == talon[1])
        {
            talon[0] = r;
            printf("Preklopio sam.\n");
        }
        else
        {
            printf("Nemam adekvatnu kartu..\n");
        }

        printf("Talon: %d %d\n", talon[0], talon[1]);
        sleep(1);
        ind = semop(semid, &V, 1);
        if(ind == -1) break;

    }
    
    return 0;
}