#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

/*
Napisati programe server.c i klijent.c. Server čeka da mu se prijavi N klijenata (N je paran
broj manji od 21). Svakom klijentu, u zavisnosti od redosleda prijavljivanja, prosleđuje se redni broj
(od 1 do N). Nakon završene prijave, klijenti razmenjuju po jednu poruku, i to tako da prvo klijent
sa neparnim rednim brojem šalje poruku klijentu sa rednim brojem za jedan većim, zatim klijent sa
parnim rednim brojem odgovara na tu poruku. Poruke učitati sa standardnog ulaza.

/*
k1:

sacekaj na znak od servera da mozes da krenes
posalji poruku k2

k2:

primi poruku od k1 kao signal da mozes da krenes
posalji poruku k3

k3:

primi poruku od k2
posalji poruku k4


k1:
primi poruku od servera
posalji poruku k2

k2:
primi poruku od k1
posalji poruku k1
posalji poruku-signal k3

k3:
primi poruku-sgnal od k2
posalji poruku k4

k4:
primi poruku od k3
posalji poruku k3
posalji poruku k5
*/


struct mojaPoruka {
	long tip;
	int pid;
	int redniBroj;
	char text[25];
};




int main(void) {
	
	key_t kljuc = ftok("server.c", 65);
	if (kljuc == -1) { perror("ftok"); exit(1); }
	
	int red =  msgget(kljuc, IPC_CREAT | 0666);
	if (red == -1) { perror("msgget"); exit(1); }

	
	struct mojaPoruka poruka;
	//posalji prijavu
	poruka.tip = 99;
	poruka.pid = getpid();
	msgsnd(red, &poruka, sizeof(poruka), 0);
	msgrcv(red, &poruka, sizeof(poruka), getpid(), 0);
	printf("Moj redni broj: %d\n", poruka.redniBroj);
	
	int rb = poruka.redniBroj;
		
	if (rb % 2 == 1) {
		//NEPARNI
		msgrcv(red, &poruka, sizeof(poruka), rb, 0);
		printf("Unesi poruku za klijenta # %d\n", rb + 1);
		scanf("%s", poruka.text);
		poruka.tip = rb + 1;
		msgsnd(red, &poruka, sizeof(poruka), 0);
		printf("Poslata poruka.\n");	
		msgrcv(red, &poruka, sizeof(poruka), rb, 0);
		printf("Primio sam poruku od #%d : %s\n", rb+1, poruka.text);	
		printf("Zavrsavam\n");
		exit(0);
		
	} else {
		//PARNI
		msgrcv(red, &poruka, sizeof(poruka), rb, 0);
		printf("Primljena poruka od #%d : %s\n", rb -1, poruka.text);
		printf("Unesi poruku za klijenta #%d\n", rb - 1);
		scanf("%s", poruka.text);
		poruka.tip = rb - 1;
		msgsnd(red, &poruka, sizeof(poruka), 0);
		printf("Poslata poruka.\n");	
		poruka.tip = rb + 1;		
		msgsnd(red, &poruka, sizeof(poruka), 0);
		printf("Zavrsavam\n");
		exit(0);
	}

	return 0;
}
