#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <time.h>

/*
Napisati program kojim će se kreirati procesi roditelj i dete. Proces roditelj ispisuje sve
parne brojeve manje od N dok proces dete ispisuje sve neparne brojeve manje od N. Posle svakog
ispisanog broja staviti random sleep. Vrednost N se unosi sa tastature.
Proces dete nije moguće prekinuti signalom SIGINT (na signal SIGINT ispisati poruku da prekid nije
moguć). Proces roditelj moguće prekinuti signalom SIGINT. Ako proces roditelj dobije signal SIGINT,
pre završetka rada, procesu detetu šalje signal SIGKILL.*/


pid_t pid;

void shRoditelj(int sig) {
	printf("PROCES RODITELJ: Dobio sam signal SIGINT.\n");
	printf("PROCES RODITELJ: Saljem detetu signal SIGKILL i zavrsavam sa radom\n");
	kill(pid, SIGKILL);
	exit(0);
}


void shDete(int sig) {
	printf("PROCES DETE: Prekid nije moguc!\n");
}

int main(void) {
	
	int N, i;
	printf("Unesi N:"); 
	scanf("%d", &N);
	
	pid = fork();
	if (pid == -1) {
		perror("fork");
		exit(1);
	}
	
	if (pid == 0) {
		//DETE
		//neparni brojevi manji od N
		signal(SIGINT, shDete);
		srand(time(NULL));
		printf("PROCES DETE: Svi neparni brojevi manji od N su:\n");
		for (i = 1; i < N; i += 2) {
			printf("DETE: %d\n", i);
			sleep(rand() % 7);
		}
	} else {
		//RODITELJ
		//parni brojevi manji od N
		signal(SIGINT, shRoditelj);
		srand(time(NULL));
		printf("PROCES RODITELJ: Svi parni brojevi manji od N su:\n");
		for (i = 2; i < N; i += 2) {
			printf("RODITELJ: %d\n", i);
			sleep(rand() % 7);
		}
	}
	
	
	return 0;
}
