#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive
int red_kom_id,red_info_id;

//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long tip;
	int rbr;
};

struct poruka_potez
{
	long tip;
	char tekst_poruke[20];
	int rbr;
};

struct poruka_partija
{
	long tip;
	int rbr, br;
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2) {
	struct poruka_potez pot;
	char rec[100];
	int duzina;
	//TODO :  primi poruku od klijenta 
	msgrcv(red_kom_id, &pot, sizeof(pot),rbr1,0);
	strcpy(rec, pot.tekst_poruke);
	duzina=strlen(rec);
	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
		strcpy(pot.tekst_poruke, "Pobedio");
		pot.tip=rbr1;
		msgsnd(red_kom_id,&pot,sizeof(pot), 0);
		strcpy(pot.tekst_poruke, "Izgubio");
		pot.tip=rbr2;
		msgsnd(red_kom_id,&pot,sizeof(pot), 0);
		struct poruka_partija pobednik;
		//TODO: Upisati u red partija redni broj pobednika
		pobednik.rbr=rbr1;
		pobednik.br++;
		msgsnd(red_info_id,&pobednik,sizeof(pobednik), 0);
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		strcpy(pot.tekst_poruke, "partija traje");
		pot.tip=rbr2;
		msgsnd(red_kom_id,&pot,sizeof(pot), 0);
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	int parni = 0;
	int neparni = 0;
	int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	waitpid(SIGCHLD, NULL, 0);
	//TODO : Procitaj statistiku i ispiši na standardni izlaz

	for(i=0; i<pobednik.br; i++)
	{
		msgrcv(red_info_id, &pobednik,sizeof(pobednik), 5,0);
		if(pobednik.rbr %2 ==1)
			neparni++;
		else
			parni++;
	}
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red_kom_id, IPC_RMID, NULL);
	msgctl(red_info_id, IPC_RMID, NULL);
	exit(0);
}

int main() {
	key_t kljuc_reda_kom, kljuc_reda_info;
	struct poruka_prijava prijava1, prijava2;
	int rbr=0;
	
	
	// TODO : Kreiraj redove
	kljuc_reda_kom=ftok("./kostur-server.c", 42);
	kljuc_reda_info=ftok("./kostur-klijent.c", 62);
	red_kom_id = msgget(kljuc_reda_kom, IPC_CREAT|0666);
	red_info_id = msgget(kljuc_reda_info, IPC_CREAT|0666);
	
	
	while(1) {
		// TODO : Prijava klijenta, fork, igra
		
		msgrcv(red_kom_id, &prijava1, sizeof(prijava1), 1, 0);
		prijava1.rbr=rbr;
		rbr++;
		
		msgsnd(red_kom_id,&prijava1,sizeof(prijava1), 0);
			
		msgrcv(red_kom_id, &prijava2, sizeof(prijava2), 1, 0);
		prijava2.rbr=rbr;
		rbr++;
		msgsnd(red_kom_id,&prijava2,sizeof(prijava2), 0);
		
		if(fork())
		{
			signal(SIGINT,sighandler);	
		}
		else
		{
			signal(SIGINT,SIG_IGN);
		}
		
		while(proveri_rec(prijava1.rbr,prijava1.rbr))
		{
			
		};
		
	}
	return 0;
}
// Ne zaboravite signale :) 
