#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

// Deklarisati potrebne globalne promenljive
int red_kom_id;
int red_info_id;

// Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long id;
	char broj[100];
};

struct poruka_potez
{
	long id;
	char tekst[100];
};

struct poruka_partija
{
	long id;
	int id_pobednika;
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2) {
	struct poruka_potez pot;
	char rec[100];
	int duzina;
	// primi poruku od klijenta
	msgrcv(red_kom_id, &pot, sizeof(pot), 50 + rbr1, 0);
	strcpy(rec, pot.tekst);
	duzina = strlen(rec);
	printf("%c %c\n", pot.tekst[duzina-3], pot.tekst[duzina-2]);
	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		// Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
		strcpy(pot.tekst, "pobeda");
		pot.id = rbr1;
		msgsnd(red_kom_id, &pot, sizeof(pot), 0);
		strcpy(pot.tekst, "poraz");
		pot.id = rbr1;
		msgsnd(red_kom_id, &pot, sizeof(pot), 0);
		struct poruka_partija pobednik;
		// Upisati u red partija redni broj pobednika
		pobednik.id = 1;
		pobednik.id_pobednika = rbr1;
		msgsnd(red_info_id, &pobednik, sizeof(pobednik), 0);
		return 1; // partija je gotova
	}
	else {
		// prosledi poruku drugom igracu
		pot.id = rbr2;
		msgsnd(red_kom_id, &pot, sizeof(pot), 0);
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	msgctl(red_kom_id, IPC_RMID, 0);
	/*
	int parni = 0;
	int neparni = 0;
	int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red_kom_id, IPC_RMID, NULL);
	msgctl(red_info_id, IPC_RMID, NULL);*/
	exit(0);
}

int main() {
	key_t kljuc_reda_kom, kljuc_reda_info;
	struct poruka_prijava prijava1, prijava2;
	int rbr=0;
	//int stat;
	int rbr1, rbr2, pid_partija;
	
	signal(SIGINT, sighandler);
	// Kreiraj redove
	kljuc_reda_kom = ftok("./kostur-server.c", 11);
	red_kom_id = msgget(kljuc_reda_kom, IPC_CREAT|0666);
	kljuc_reda_info = ftok("./kostur-server.c", 66);
	red_info_id = msgget(kljuc_reda_info, IPC_CREAT|0666);
	
	
	while(rbr <= MAX_PARTIJA) {
		// Prijava klijenta, fork, igra
		msgrcv(red_kom_id, &prijava1, sizeof(prijava1), 50, 0);
		prijava1.id = prijava1.broj[0];
		prijava1.broj[0] = ++rbr;
		msgrcv(red_kom_id, &prijava2, sizeof(prijava2), 50, 0);
		prijava2.id = prijava2.broj[0];
		prijava2.broj[0] = ++rbr;
		msgsnd(red_kom_id, &prijava1, sizeof(prijava1), 0);
		msgsnd(red_kom_id, &prijava2, sizeof(prijava2), 0);
		rbr1 = rbr - 1;
		rbr2 = rbr;
		if((pid_partija = fork()) == 0){
			while(1){
				if(proveri_rec(rbr1, rbr2)) break;
				if(proveri_rec(rbr2, rbr1)) break;
			}
		}
	}
	return 0;
}
