#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive
int red_kom_id,red_info_id;
int brIgr;
int igraci[40];

//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long tip;
	int pid;
	int rb;
};

struct poruka_potez
{
	long tip;
	int rbr;
	char tekst[100];
};

struct poruka_partija
{
	long tip;
	int rbrPob;
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2) {
	struct poruka_potez pot;
	char rec[100];
	int duzina;
	//TODO :  primi poruku od klijenta 
	msgrcv(red_kom_id,&pot,sizeof(pot),2,0);
	strcpy(rec,pot.tekst);
	if(pot.rbr != rbr1){
			int pom;
			pom=rbr1;
			rbr1=rbr2;
			rbr2=pom;
		}

	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
		pot.tip=igraci[rbr1-1];
		strcpy(pot.tekst,"pobeda");
		msgsnd(red_kom_id,&pot,sizeof(pot),0);
		pot.tip=igraci[rbr2-1];
		strcpy(pot.tekst,"poraz");
		msgsnd(red_kom_id,&pot,sizeof(pot),0);

		struct poruka_partija pobednik;
		//TODO: Upisati u red partija redni broj pobednika
		pobednik.tip=1;
		pobednik.rbrPob=rbr1;
		msgsnd(red_info_id,&pobednik,sizeof(pobednik),0);
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		pot.tip=igraci[rbr2-1];
		msgsnd(red_kom_id,&pot,sizeof(pot),0);
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	int parni = 0;
	int neparni = 0;
	int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	for(i=0;i<brIgr;i++) wait(NULL);

	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	for(i=0;i<brIgr;i++) {
		msgrcv(red_info_id,&pobednik,sizeof(pobednik), 1, IPC_NOWAIT);
		if(pobednik.rbrPob%2 == 0) parni++;
		else neparni++;
	}

	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red_kom_id, IPC_RMID, NULL);
	msgctl(red_info_id, IPC_RMID, NULL);
	exit(0);
}

int main() {
	signal(SIGINT,sighandler);
	key_t kljuc_reda_kom, kljuc_reda_info;
	struct poruka_prijava prijava1, prijava2;
	int rbr=0;
	int stat;
	int rbr1, rbr2, pid_partija;
	
	// TODO : Kreiraj redove
	kljuc_reda_kom = ftok("./server.c",65);
	kljuc_reda_info = ftok("./server.c",66);
	red_kom_id = msgget(kljuc_reda_kom,IPC_CREAT|0666);
	red_info_id = msgget(kljuc_reda_info,IPC_CREAT|0666);
	
	rbr1=1;
	rbr2=2;
	brIgr=0;
	//printf("%d, %d\n",red_kom_id,red_info_id);
	while(1) {
		sleep(1);
		signal(SIGINT,SIG_IGN);
		// TODO : Prijava klijenta, fork, igra
		prijava1.tip=0;
		prijava1.pid=-1;
		prijava1.rb=-1;
		msgrcv(kljuc_reda_kom,&prijava1,sizeof(prijava1),1,0);
		printf("tip=%ld pid=%d\n",prijava1.tip,prijava1.pid);
		prijava1.tip=prijava1.pid;
		prijava1.rb = rbr1; rbr1+=2;
		igraci[rbr1-1]=prijava1.pid;
		msgsnd(kljuc_reda_kom,&prijava1,sizeof(prijava1),0);

		msgrcv(kljuc_reda_kom,&prijava2,sizeof(prijava2),1,0);
		prijava2.tip=prijava2.pid;
		prijava2.rb = rbr2; rbr2+=2;
		igraci[rbr2-1]=prijava2.pid;
		msgsnd(kljuc_reda_kom,&prijava1,sizeof(prijava1),0);

		/*int pid=fork();
		brIgr++;
		if(pid==0){
			int mb1,mb2;
			mb1=rbr1;
			mb2=rbr2;
			while(proveri_rec(mb1,mb2));
			exit(0);
		}*/
	}
	return 0;
}
// Ne zaboravite signale :) 
