#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <sys/wait.h>

#define MAX_PARTIJA 20
#define PUTANJA "./kostur-server.c"
#define PROJEKAT 10
#define MAX_IGRACA 10
#define MAX_TEKST 50
#define TACNO 1
#define NETACNO 0 
int nk, nd;
long klijenti[MAX_IGRACA];
pid_t djeca[MAX_IGRACA];

typedef struct {
	long pid;
	char tekst[MAX_TEKST];
	int redniBroj, status;
} poruka;

/* Ako zavrsava sa NT, vrati 1. */
int provjerint(char *s) {
	int i;
	for(i=0; s[i]!='\0'; i++);
	i=i-2;
	if((s[i]=='n') && (s[i+1]=='t'))
		return 1;
	else return 0; 
}


/* Ako se posljednja dva slova prve rijeci podudaraju sa prva dva slova druge rijeci, vrati 1. */
int provjerikraj(char *s1, char *s2) {
	int i;
	for(i=0; s1[i]!='\0'; i++);
	i=i-2;
	if((s1[i]==s2[0]) && (s1[i+1]==s2[1]))
		return 1;
	else return 0;
}

int main(void) {
	poruka p;
	int red, redniBroj, i;
	
	/* PID procesa koristimo kao tip poruke. */
	pid_t pid=getpid();
	
	key_t kljuc=ftok(PUTANJA, PROJEKAT);
	red=msgget(kljuc, IPC_CREAT|0666);
	
	p.pid=pid;
	
	printf("Saljem prijavu.\n");
	msgsnd(red, &p, sizeof(p), pid);
	
	msgrcv(red, &p, sizeof(p), pid, 0);
	redniBroj=p.redniBroj;
	printf("Dobijen br. prijave: %d\n", p.redniBroj);
	
	for(;;) {
		if(redniBroj%2==0) {
			msgrcv(red, &p, sizeof(p), pid, 0);
		} else {
			printf("Unesi rijec:");
			fscanf(stdin, "%s", p.tekst);
		}
		printf("Prihvacena rijec %s. Unesi novu:\n", p.tekst);
		static char buffer[MAX_TEKST];
		s: fscanf(stdin, "%s", buffer);
		if(!provjerint(buffer)) {
			if(!provjerikraj(p.tekst, buffer)) {
				printf("Unesi ponovo:\n");
				goto s;
			} else {
				p.status=TACNO;
			}
		} else {
			printf("Rijec zavrsava sa NT.\n");
			p.status=NETACNO;
		}
		msgsnd(red, &p, sizeof(p), pid);
	}
	return 0;
}
