#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <errno.h>
#include <string.h>
#include <signal.h>

typedef struct _data1
{
    int pid;
    int id;
} Data1;

typedef struct _data2
{
    char word[20];
    int myPid;
    int id;
} Data2;

typedef struct _data_win 
{
    long tip;
    struct _data1 data;
} DataWin;

typedef struct _data_word
{
    long tip;
    Data2 data;
} DataWord;

void sigint_handler(int sig)
{
    //printf("Caught SIG_INT");
    
};

int main()
{
    //signal(SIGINT, sigint_handler);
    key_t key = ftok("./win-data", 1);
    key_t key2 = ftok("./data-comm", 1);
    int id_queue = msgget(key, IPC_CREAT|0666);
    int id_queue2 = msgget(key2, IPC_CREAT|0666);
    int shouldWork = 1;
    pid_t games_pid[1000];
    int i = 0;
    DataWin players[2];
    DataWord word;
    int winner;
    while(shouldWork && i<20)
    {
        //printf("Waiting for player %d\n", (i+1)*2-1);
        msgrcv(id_queue, &players[0], sizeof(players[0]), 2, 0);
        printf("Player %d(%d) joined\n", (i+1)*2-1, players[0].data.pid);
        //printf("Waiting for player %d\n", (i+1)*2);
        msgrcv(id_queue, &players[1], sizeof(players[1]), 2, 0);
        printf("Player %d(%d) joined\n", (i+1)*2, players[1].data.pid);
        i++;
        printf("Another game should start\n");
        games_pid[i-1] = fork();
        printf("Forked : %d\n", games_pid[i-1]);
        if(games_pid[i-1] == 0)
        {
            printf("Game started for %d(%d) and %d(%d)\n", i*2-1, players[0].data.pid, i*2, players[1].data.pid);
            printf("My PID is %d\n", getpid());
            players[0].data.id = i*2-1;
            players[1].data.id = i*2;
            winner = -1;
            word.tip = players[0].data.pid;
            word.data.myPid = getpid();
            word.data.id = i*2-1;
            strcpy(word.data.word, "");
            msgsnd(id_queue2, &word, sizeof(word), 0);
            msgrcv(id_queue2, &word, sizeof(word), getpid(), 0);
            printf("Got first word : %s", word.data.word);
            while(1)
            {
                if(winner == 0)
                {
                    word.tip = players[0].data.pid;
                    word.data.myPid = getpid();
                    word.data.id = i*2-1;
                    msgsnd(id_queue2, &word, sizeof(word), 0);
                    msgrcv(id_queue2, &word, sizeof(word), getpid(), 0);
                }
                if(winner == 0 && word.data.word[strlen(word.data.word-1)] == 'T' && word.data.word[strlen(word.data.word-2)] == 'N')
                {
                    winner = players[0].data.id;
                    printf("End");
                    break;
                }
                else
                {
                    winner = 0;
                    word.tip = players[1].data.pid;
                    word.data.myPid = getpid();
                    word.data.id = i*2;
                    msgsnd(id_queue2, &word, sizeof(word), 0);
                    msgrcv(id_queue2, &word, sizeof(word), getpid(), 0);
                    if(word.data.word[strlen(word.data.word-1)] == 'T' && word.data.word[strlen(word.data.word-2)] == 'N')
                    {
                        winner = players[1].data.id;
                        printf("End");
                        break;
                    }
                }
            }
            printf("Game ended. Winner %d\n", winner);
            DataWin datawin;
            datawin.tip = winner%2;
            msgsnd(id_queue, &datawin, sizeof(datawin), 0);
        }
    }
}