#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>
#include <string.h>

#define MAX_MESSAGE_LENGTH 50
#define MESSAGE_INFO "Message received"

typedef struct SignInMessage {
    long mtype;
    int pid;
} SignInMessage;

typedef struct SignOffMessage {
    long mtype;
} SignOffMessage;

typedef struct Response {
    long mtype;
    int ordinalNumber;
} Response;

typedef struct Message {
    long mtype;
    char content[MAX_MESSAGE_LENGTH];
} Message;

int signInOnServer(int msqid) {
    SignInMessage signInMessage;
    signInMessage.mtype = 1;
    signInMessage.pid = getpid();

    msgsnd(msqid, &signInMessage, sizeof(signInMessage) - sizeof(long), 0);

    Response responseMessage;
    msgrcv(msqid, &responseMessage, sizeof(responseMessage) - sizeof(long), getpid(), 0);

    return responseMessage.ordinalNumber;
}

Message receiveMessage(int msqid, int type) {
    Message message;
    msgrcv(msqid, &message, sizeof(message) - sizeof(long), type, 0);
    return message;
}

void sendMessage(int msqid, Message message) {
    msgsnd(msqid, &message, sizeof(message) - sizeof(long), 0);
}

int main() {
    
    int uniqueId = ftok("./server.c", 'a');
    int msgflg = IPC_CREAT | 0666;
    int msqid = msgget(uniqueId, msgflg);

    int ordinalNumber = signInOnServer(msqid);

    Message message;
    if (ordinalNumber % 2 == 0) {
        // receive send

        message = receiveMessage(msqid, ordinalNumber);
        printf("%s: %s\n", MESSAGE_INFO, message.content);
        
        printf("Enter a reply message:\n");
        fgets(message.content, MAX_MESSAGE_LENGTH, stdin);
        
        message.content[strlen(message.content) - 1] = '\0';
        message.mtype = ordinalNumber - 1;

        // sleep(3);

        sendMessage(msqid, message);
    } else {
        // send receive

        printf("Enter a message:\n");
        fgets(message.content, MAX_MESSAGE_LENGTH, stdin);
        
        message.content[strlen(message.content) - 1] = '\0';
        message.mtype = ordinalNumber + 1;

        // sleep(3);

        sendMessage(msqid, message);

        message = receiveMessage(msqid, ordinalNumber);
        printf("%s: %s\n", MESSAGE_INFO, message.content);
    }

    // sign off
    SignOffMessage signOffMessage;
    signOffMessage.mtype = 1;

    msgsnd(msqid, &signOffMessage, sizeof(signOffMessage) - sizeof(long), 0);

    return 0;
}