#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct SignInMessage {
    long mtype;
    int pid;
} SignInMessage;

typedef struct SignOffMessage {
    long mtype;
} SignOffMessage;

typedef struct Response {
    long mtype;
    int ordinalNuber;
} Response;

void registerClients(int msqid, int n) {
    int clientPids[n];

    SignInMessage signInMessage;
    Response responseMessage;

    for (int i = 0; i < n; i++) {
        msgrcv(msqid, &signInMessage, sizeof(signInMessage) - sizeof(long), 1, 0);
        clientPids[i] = signInMessage.pid;
    }

    for (int i = 0; i < n; i++) {
        responseMessage.mtype = clientPids[i];
        responseMessage.ordinalNuber = i + 1;
        msgsnd(msqid, &responseMessage, sizeof(responseMessage) - sizeof(long), 0);
    }
}

void unloadClients(int msqid, int numberOfClients) {
    SignOffMessage signOffMessage;
    for (int i = 0; i < numberOfClients; i++) {
        msgrcv(msqid, &signOffMessage, sizeof(signOffMessage) - sizeof(long), 1, 0);
    }
}

void removeQueue(int msqid) {
    msgctl(msqid, IPC_RMID, NULL);
}

int main() {

    int numberOfClients;

    printf("Enter number of clients:\n");
    scanf("%d", &numberOfClients);
    getc(stdin);

    int uniqueId = ftok("./server.c", 'a');
    int msgflg = IPC_CREAT | 0666;
    int msqid = msgget(uniqueId, msgflg);

    registerClients(msqid, numberOfClients);

    unloadClients(msqid, numberOfClients);

    removeQueue(msqid);

    return 0;
}