#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

typedef struct Poruka_s{
	long tip;
	char tekst[30];
	pid_t pid;
	int redni_broj;
}Poruka;

//Prvo se pokrene broj(paran) klijenata, pa se server pokrene.

void main()
{
	key_t kljuc1, kljuc2;
	int br, n, red1, red2, pv;
	Poruka salji, primi;

	kljuc1 = ftok("./klijent.c", 60);
	red1 = msgget(kljuc1, IPC_CREAT|0666);
	kljuc2 = ftok("./server.c", 70);
	red2 = msgget(kljuc2, IPC_CREAT|0666);

	salji.pid = getpid();
	salji.tip = 1;

	pv = msgsnd(red1, &salji, sizeof(salji), 0);
	if(pv == -1)
	{
		printf("Greska pri slanju poruke!\n");
		exit(0);
	}

	primi.tip = salji.pid;
	pv = msgrcv(red2, &primi, sizeof(primi), primi.tip, 0);
	if(pv == -1)
	{
		printf("Greska pri slanju poruke!\n");
		exit(0);
	}

	//printf("Redni broj: %d\n", primi.redni_broj);

	if(primi.redni_broj % 2 == 1)
	{
		salji.tip = primi.redni_broj + 1;
		printf("Unesi poruku: ");
		fgets(salji.tekst, sizeof(salji.tekst), stdin);
		salji.tekst[strlen(salji.tekst)-1] = '\0';

		pv = msgsnd(red1, &salji, sizeof(salji), 0);
		if(pv == -1)
		{
			printf("Greska pri slanju poruke!\n");
			exit(0);
		}
		else
			printf("Poruka %s je poslata!\n\n", salji.tekst);

		//////////////////////////////////////////////////////////

		primi.tip = primi.redni_broj;
		pv = msgrcv(red2, &primi, sizeof(primi),primi.tip ,0);
		if(pv == -1)
		{
			printf("Greska pri primanju poruke!\n");
			exit(0);
		}
		else
			printf("Odgovor: %s\n", primi.tekst);
	}
	else
	{
		primi.tip = primi.redni_broj;
		pv = msgrcv(red1, &primi, sizeof(primi),primi.tip ,0);
		if(pv == -1)
		{
			printf("Greska pri primanju poruke!\n");
			exit(0);
		}
		else
			printf("Primljena: %s\n", primi.tekst);

		//////////////////////////////////////////////////////////

		salji.tip = primi.tip - 1;
		printf("Unesi poruku: ");
		fgets(salji.tekst, sizeof(salji.tekst), stdin);
		salji.tekst[strlen(salji.tekst)-1] = '\0';
		pv = msgsnd(red2, &salji, sizeof(salji), 0);
		if(pv == -1)
		{
			printf("Greska pri slanju poruke!\n");
			exit(0);
		}
		else
			printf("Poruka %s je poslata!\n\n", salji.tekst);
	}
}
