#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive
int red_kom_id, red_info_id;


//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
typedef struct {
	long tip;
	char text[20];
	int rbr;
	pid_t pid;
}poruka_prijava;

typedef struct {
	long tip;
	int na_redu;
	char text[20];
}poruka_potez;

typedef struct {
	pid_t pid;
}poruka_partija;

poruka_partija *pid_dece;


// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2, int i) { //rbr1 i rbr2 je pid trenutnih igraca
	printf("%d %d\n", rbr1, rbr2);
	poruka_potez pot, poslati;
	char rec[100];
	int duzina;
	//TODO :  primi poruku od klijenta 
	msgrcv(red_kom_id, &pot, sizeof(pot.text), rbr1,0); //primi poruku od prvog igraca
	strcpy(rec, pot.text);
	duzina = strlen(rec);
	if (rec[duzina-3]=='n' && rec[duzina-2]=='t') {
		//kraj igre
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
		strcpy(poslati.text, "pobeda");
		poslati.tip = rbr1;
		msgsnd(red_kom_id, &poslati, sizeof(poslati.text), 0); //prvom poslao da je pobedio
		strcpy(poslati.text, "poraz");
		poslati.tip = rbr2;
		msgsnd(red_kom_id, &poslati, sizeof(poslati.text), 0); //drugom poslao da je izgubio
		
		//poruka_partija pobednik;
		//TODO: Upisati u red partija redni broj pobednika
		pid_dece[i].pid = rbr1;
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
		strcpy(pot.text, rec);
		pot.tip = rbr2;
		msgsnd(red_kom_id, &pot, sizeof(pot.text), 0); //posalji rec prvog igraca drugom igracu
		
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	int parni = 0;
	int neparni = 0;
	//int i;
	//poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
	
	
	
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red_kom_id, IPC_RMID, NULL);
	msgctl(red_info_id, IPC_RMID, NULL);
	exit(0);
}

int main() {
	key_t kljuc_reda_kom, kljuc_reda_info;
	poruka_prijava prijava1, prijava2;
	int rbr=0;
	int rbr1=0, rbr2=0;
	pid_dece = (poruka_partija*)malloc(MAX_PARTIJA*sizeof(poruka_partija));
	poruka_potez na_potezu, poslata;
	
	
	// TODO : Kreiraj redove
	kljuc_reda_kom = ftok("./server.c", 66);
	kljuc_reda_info = ftok("./klijent.c", 77);
	red_kom_id = msgget(kljuc_reda_kom, IPC_CREAT | 0666);
	red_info_id = msgget(kljuc_reda_info, IPC_CREAT | 0666);
	
	while(1) {
		//ceka igrace da se prijave
		msgrcv(red_kom_id, &prijava1, sizeof(prijava1.text), 2, 0);
		msgrcv(red_kom_id, &prijava2, sizeof(prijava2.text), 2, 0); 
		//posalji informacije o tome koj je na redu
		rbr1++;
		rbr2++;
		prijava1.rbr = rbr1;
		prijava2.rbr = rbr2;
		prijava1.tip = 1;
		prijava2.tip = 1;
		msgsnd(red_kom_id, &prijava1, sizeof(prijava1.rbr), 0);
		msgsnd(red_kom_id, &prijava2, sizeof(prijava2.rbr), 0);
		
		if(fork()==0){ //vodi racuna o partiji
			//posalji poruku neparnom igracu da posalje rec
			na_potezu.tip = prijava1.pid;
			na_potezu.na_redu = prijava1.rbr;
			msgsnd(red_kom_id, &na_potezu, sizeof(na_potezu.na_redu), 0); //poslati prvom igracu poruku da je na redu
			
			if(proveri_rec(prijava1.pid, prijava2.pid, rbr) == 0) {
					pid_dece[rbr++].pid = prijava1.pid;
			}
			else{
				 printf("Patrija igraca %d i %d je gotova.\n", rbr1, rbr2);
				 poslata.tip = prijava1.pid;
				 strcpy(poslata.text, "pobeda");
				 msgsnd(red_info_id, &poslata, sizeof(poslata.text), 0);
				 poslata.tip = prijava2.pid;
				 strcpy(poslata.text, "poraz");
				 msgsnd(red_info_id, &poslata, sizeof(poslata.text), 0);
			}
			signal(SIGINT, SIG_IGN);
		}
		
		//uhvati signal
		signal(SIGINT, sighandler);
	}
	return 0;
}
// Ne zaboravite signale :) 
