#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <unistd.h>
#include <sys/wait.h>
#include <signal.h>

#define MAX_PARTIJA 20

//TODO : Deklarisati potrebne globalne promenljive
int red_kom_id; // id reda za komunikaciju 
int red_info_id; // id reda za info
int dete;

//TODO : Definisati potrebne strukture za razmenu poruka (može i drugačije)
struct poruka_prijava
{
	long mtype;
    int br;
};

struct poruka_potez
{
	long mtype;
    int rb;
    char rec[20];
};

struct poruka_partija
{
    int mtype;
    int p1;
    int p2;
};
// Za zadata dva redna broja igrača, čita poruku prvog, proverava da li je kraj igre i ako jeste šalje odgovarajuće poruke a ako nije, prosleđuje poruku drugom igraču

int proveri_rec(int rbr1, int rbr2) {
	struct poruka_potez pot;
	char rec[100];
	int duzina;
	//TODO :  primi poruku od klijenta 
    msgrcv(red_kom_id, &pot, sizeof(pot), 4, 0);
    strcpy(pot.rec,rec);
    printf("%s\n",pot.rec);
	if (rec[duzina-2]=='n' && rec[duzina-1]=='t') {
		
		printf("Partija igraca %d i %d je gotova\n", rbr1, rbr2);
		// TODO: Poslati poruku prvom igracu da je pobedio a drugom da je izgubio
        if(pot.rb == rbr1)
        {
            pot.mtype = rbr1;
            strcpy(pot.rec,"pobeda");
            msgsnd(red_kom_id, &pot, sizeof(pot), 0);

            pot.mtype = rbr2;
            strcpy(pot.rec,"poraz");
            msgsnd(red_kom_id, &pot, sizeof(pot), 0);
            
        }else
        {
            pot.mtype = rbr1;
            strcpy(pot.rec,"poraz");
            msgsnd(red_kom_id, &pot, sizeof(pot), 0);

            pot.mtype = rbr2;
            strcpy(pot.rec,"pobeda");
            msgsnd(red_kom_id, &pot, sizeof(pot), 0);
            
        }
		
		struct poruka_partija pobednik;
		//TODO: Upisati u red partija redni broj pobednika
		return 1; // partija je gotova
	}
	else {
		//TODO: prosledi poruku drugom igracu
        if(pot.rb == rbr1)
        {// posalji na 2
            pot.mtype = rbr2;
        }else
        {// posalji na 1
            pot.mtype = rbr1;
        }
        msgsnd(red_kom_id, &pot, sizeof(pot), 0);
		
		return 0; // partija još uvek traje
	}
}


void sighandler(int sig) {
	int parni;
	int neparni;
	int i;
	struct poruka_partija pobednik;
	//TODO : Sačekaj svu decu da završe
	
	//TODO : Procitaj statistiku i ispiši na standardni izlaz
    while(msgrcv(red_info_id, &pobednik, sizeof(pobednik), 0, IPC_NOWAIT) != -1);
    parni = pobednik.p2;
	neparni = pobednik.p1;
	
	printf("Turnir je zavrsen\n");
	printf("Neparna/parna pozicija - %d/%d\n", neparni, parni);
	msgctl(red_kom_id, IPC_RMID, NULL);
	msgctl(red_info_id, IPC_RMID, NULL);
	exit(0);
}

int main() {
    signal(SIGINT,sighandler);
	key_t kljuc_reda_kom, kljuc_reda_info;
	struct poruka_prijava prijava1, prijava2;
    struct poruka_potez tpotez;
	int rbr=0;
	int stat = 0;
	int rbr1, rbr2, pid_partija;
	
	
	// TODO : Kreiraj redove || REDOVI KREIRANI
	kljuc_reda_kom = ftok("server.c",'K');
	red_kom_id = msgget(kljuc_reda_kom, 0666 | IPC_CREAT);

    kljuc_reda_info = ftok("server.c", 'I');
	red_info_id = msgget(kljuc_reda_info, 0666 | IPC_CREAT);
	
	rbr1 = 1;
    rbr2 = 2;
	while(stat <= 20) {
		// TODO : Prijava klijenta, fork, igra

        msgrcv(red_kom_id, &prijava1, sizeof(prijava1), 2, 0); //ceka da se prijavi igrac 1
        // posalji igracu njegov redni broj
        prijava1.mtype = 3;
        prijava1.br = rbr1;
        

        msgrcv(red_kom_id, &prijava2, sizeof(prijava1), 2, 0); //ceka da se prijavi igrac 2
        // posalji igracu njegov redni broj
        prijava2.mtype = 3;
        prijava2.br = rbr2;

        msgsnd(red_kom_id, &prijava1, sizeof(prijava1), 0); // salje klijentu 1 da je uspeo da se ukljuci u igru
        msgsnd(red_kom_id, &prijava2, sizeof(prijava1), 0); // salje klijentu 2 da je uspeo da se ukljuci u igru
        
        stat++;
        pid_partija = fork();
        if(pid_partija == 0)
        {
            dete = pid_partija;
            while(proveri_rec(rbr1,rbr2) == 0);
        }
        rbr1++;
        rbr2++;
	}

	return 0;
}
// Ne zaboravite signale :) 